# Part of RXJIS
# YANO Takashi
# tyano@tk.airnet.ne.jp or tyano@jp.ibm.co.jp
# history:
# 1996-2-5 0.00 initial release
# 1996-2-14 0.10 add some options to reduce size
#                -Ol -Gu -B "/EXEPACK:2"
# 1996-3-20 0.20 Add ZIP to -9 (better compress) option
# 1996-4-15 0.30 Add -Sn (DBCS) option
# 1996-4-21 0.30 Drop EXEPACK:2
#                Add implib process
#                Add rxjis.h/rxjis.lib
# 1997-8-5 0.90 restructure the source code
# 1997-8-25 0.91 restructure the source code
# 1997-9-5 0.92 Add RxJisKanjiAlias/JisKanjiAlias function
# 1998-5-27 0.94 Add RxJisSyslog function
# 1999-12-21: 0.96 Change RxJisTrace output format

.SILENT:

CFLAGS = -Q -J -Sn -Ge-md-u -W3 -Sinp1 -Ol
CFLAGSC = -C $(CFLAGS)

RXJIS.OBJ: $(@B).CPP $(@B).H PCTOJIS.HPP
   icc $(CFLAGSC) $(@B).CPP

PCTOJIS.OBJ: $(@B).CPP $(@B).HPP PC2JIS.HPP IBM2JIS.HPP
   icc $(CFLAGSC) $(@B).CPP

PC2JIS.CPP: $(@B).CMD $(@B).DAT
   call $(@B)

PC2JIS.OBJ: $(@B).CPP $(@B).HPP
   icc $(CFLAGSC) $(@B).CPP

IBM2JIS.CPP: $(@B).CMD $(@B).DAT
   call $(@B)

IBM2JIS.OBJ: $(@B).CPP $(@B).HPP
   icc $(CFLAGSC) $(@B).CPP

RXJISTBL.OBJ: $(@B).CPP $(@B).HPP
   icc $(CFLAGSC) $(@B).CPP

JIS2PC.CPP: $(@B).CMD $(@B).DAT
   call $(@B)

JIS2PC.OBJ: $(@B).CPP $(@B).HPP
   icc $(CFLAGSC) $(@B).CPP

JISCASE.CPP: $(@B).CMD $(@B)1.DAT $(@B)2.DAT $(@B)3.DAT $(@B)4.DAT $(@B)5.DAT $(@B)6.DAT $(@B)7.DAT $(@B)8.DAT 
   call $(@B)

JISCASE.OBJ: $(@B).CPP $(@B).HPP
   icc $(CFLAGSC) $(@B).CPP

RXJISDT.CPP:
   if exist $(@B).CPP erase $(@B).CPP
   echo char * _Export RxJisDate = __DATE__; >>$(@B).CPP
   echo char * _Export RxJisTime = __TIME__; >>$(@B).CPP

RXJISDT.OBJ: $(@B).CPP
   icc $(CFLAGSC) $(@B).CPP

RXJIS.DLL: RXJIS.OBJ PCTOJIS.OBJ PC2JIS.OBJ IBM2JIS.OBJ RXJIS.DEF RXJISDT.OBJ JIS2PC.OBJ RXJISTBL.OBJ JISCASE.OBJ
   icc $(CFLAGS) -Fm -Fe$(@B).DLL -B"/EXEPACK:2 /OPTFUNC /NODEBUG" -Oc RXJIS.OBJ PCTOJIS.OBJ PC2JIS.OBJ IBM2JIS.OBJ RXJIS.DEF REXX.LIB RXJISDT.OBJ JIS2PC.OBJ RXJISTBL.OBJ JISCASE.OBJ TCP32DLL.LIB SO32DLL.LIB
   mapsym $(@B)
   implib /NOI $(@B).lib $(@B).def

RXJIS.ZIP: RXJIS.CPP RXJIS.MAK RXJIS.DLL RXJIS.DEF RXJIS.MAK BUILD.CMD MIMESEND.CMD MIMERECV.CMD RXJIS.DOC RXJIS.H RXJIS.LIB IBM2JIS.DAT IBM2JIS.CMD PC2JIS.DAT PC2JIS.CMD PCTOJIS.CPP PCTOJIS.HPP PC2JIS.HPP IBM2JIS.HPP FMTTEXT3.ERX JIS2PC.CMD JIS2PC.HPP JIS2PC.DAT JISCASE1.DAT JISCASE.CMD JISCASE2.DAT JISCASE3.DAT JISCASE4.DAT JISCASE5.DAT JISCASE6.DAT JISCASE7.DAT JISCASE8.DAT RXJISTBL.CPP RXJISTBL.HPP JISCASE.HPP
   if exist $(@B).ZIP erase $(@B).ZIP
   zip -q9 $(@B).ZIP $**
